﻿using Microsoft.ML;
using System.IO;

namespace DataLoaders.BLL
{
    internal class BinaryDataLoader : IDataLoader
    {
        private string _filePath;
        private string _binFilePath;
        public BinaryDataLoader(string filePath)
        {
            _filePath = filePath;
            _binFilePath = $"{Path.GetFileName(filePath)}.bin";
        }
        public IDataView LoadData()
        {
            var mlContext = new MLContext();
            var myData = mlContext.Data.LoadFromTextFile<ModelInput>(_filePath, hasHeader: true, separatorChar: ',');

            using (FileStream fs = new FileStream(_binFilePath, FileMode.Create))
            {
                mlContext.Data.SaveAsBinary(myData, fs);
            }

            return mlContext.Data.LoadFromBinary(_binFilePath);
        }
    }
}
