﻿using Microsoft.ML;
using Microsoft.ML.Data;
using System;
using System.Collections.Generic;
using System.Data.Common;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DataLoaders.BLL
{
    internal class DatabaseDataLoader : IDataLoader
    {
        private string _dataSource;
        public DatabaseDataLoader(string dataSource)
        {
            _dataSource = dataSource;
        }
        public IDataView LoadData()
        {
            var mlContext = new MLContext();
            var factory = DbProviderFactories.GetFactory("System.Data.SQLite");
            var databaseSource = new DatabaseSource(factory, string.Format(@"Data Source={0}",_dataSource), "SELECT * FROM 'Iris'");
            return mlContext.Data.CreateDatabaseLoader<ModelInputDb>().Load(databaseSource);
        }
    }
}
