﻿using Microsoft.ML;
using System.IO;

namespace DataLoaders.BLL
{
    internal class TextFileDataLoader : IDataLoader
    {
        private string _filePath;
        private string _txtFilePath;
        public TextFileDataLoader(string filePath)
        {
            _filePath = filePath;
            _txtFilePath = $"{Path.GetFileName(filePath)}.txt";
        }
        public IDataView LoadData()
        {
            var mlContext = new MLContext();
            var myData = mlContext.Data.LoadFromTextFile<ModelInput>(_filePath, hasHeader: true, separatorChar: ',');

            using (FileStream fs = new FileStream(_txtFilePath, FileMode.Create))
            {
                mlContext.Data.SaveAsText(myData, fs);
            }

            return mlContext.Data.LoadFromTextFile(_txtFilePath);
        }
    }
}
